// m:  
//  3.0  29.04.2014

function MainBalls(canvas) {

    //  

    var context = canvas.getContext("2d");                  //  context  
    canvas.oncontextmenu = function (e) {return false;};    //   

    const Pi = 3.1415926;                   //  ""

    const m0 = 1;                           //  
    const T0 = 1;                           //   (   )
    const a0 = 1;                           //   ( )

    const g0 = a0 / T0 / T0;                //   (,    T0    a0)
    const k0 = 2 * Pi / T0;                 //  
    const C0 = m0 * k0 * k0;                //  
    const B0 = 2 * m0 * k0;                 //  

    // ***    ***

    const Ny = 5;                           //  ,      (     )
    const m = 1 * m0;                       // 
    const Cwall = 10 * C0;                  //  
    const B = 0.008 * B0;                   //  
    const B1 = 0.03 * B0;                   //   
    const mg = 0.25 * m * g0;               //  
    const r = 0.5 * a0;                     //     

    // ***    ***

    const fps = 50;                         // frames per second -     ( )
    const spf = 100;                        // steps per frame   -      ( )
    const dt  = 0.045 * T0 / fps;           //   ( )

    //  

    const scale = canvas.height / Ny / a0;  //         
    const r2 = r * r;                       // ___  ___

    var w = canvas.width / scale;           //     
    var h = canvas.height / scale;          //     

    var dNd = null;                         //      (drag & drop)

    //   

    var mx_, my_;                           //    (     )

    canvas.onmousedown = function(e) {      //     
        var m = mouseCoords(e);             //     
        //    ,   ,  ""
        // (..      )
        for (var i = balls.length - 1; i >= 0; i--) {
            var b = balls[i];
            var rx = b.x - m.x;
            var ry = b.y - m.y;
            b.rLen2 = rx * rx + ry * ry;        //       
            if (b.rLen2 <= r2) {                //    
                if (e.which == 1) {             //    
                    dNd = b;
                    dNd.xPlus = dNd.x - m.x;    //       x
                    dNd.yPlus = dNd.y - m.y;    //       y
                    mx_ = m.x;    my_ = m.y;
                    canvas.onmousemove = mouseMove;     //    -   
                } else if (e.which == 3) {              //    
                    balls.splice(i, 1);                 //  
                }
                return;
            }
        }

        //     return   -    ,  
        if (e.which == 1) {
            dNd = addNewBall(m.x, m.y);         //       
            if (dNd == null) return;            //     (     ) - 
            dNd.xPlus = 0;  dNd.yPlus = 0;      //    
            mx_ = m.x;    my_ = m.y;
            canvas.onmousemove = mouseMove;     //    -   
        }
    };

    document.onmouseup = function(e) {          //     
        canvas.onmousemove = null;              //    -   
        dNd = null;                             //    -    
    };

    function mouseMove(e) {                     //    ,     
        var m = mouseCoords(e);                 //     
        dNd.x = m.x + dNd.xPlus;
        dNd.y = m.y + dNd.yPlus;
        dNd.vx = 0.6 * (m.x - mx_) / dt / fps;   dNd.vy = 0.6 * (m.y - my_) / dt / fps;
        mx_ = m.x;    my_ = m.y;
    }

    function mouseCoords(e) {                   //      
        var m = [];
        var rect = canvas.getBoundingClientRect();
        m.x = (e.clientX - rect.left) / scale;
        m.y = (e.clientY - rect.top) / scale;
        return m;
    }

    //   

    var balls = [];                             //  
    var addNewBall =  function(x, y) {
        var b = [];

        b.x = x;                b.y = y;        //   
        b.fx = 0;               b.fy = mg;      // ,   
        b.vx = 0;               b.vy = 0;       // 

        balls[balls.length] = b;                //     
        return b;
    };

    //   

    function control() {
        physics();
        draw();
    }

    //   

    function physics() {                        // ,     
        for (var s = 1; s <= spf; s++) {
            for (var i = 0; i < balls.length; i++) {
                var b = balls[i];

                if (b == dNd) continue;  //     -  .      

                b.fx = - B * b.vx;
                b.fy = mg - B * b.vy;

                if (b.y + r > h) { b.fy += -Cwall * (b.y + r - h) - B1 * b.vy; }
                if (b.y - r < 0) { b.fy += -Cwall * (b.y - r) - B1 * b.vy;}
                if (b.x + r > w) { b.fx += -Cwall * (b.x + r - w) - B1 * b.vx; }
                if (b.x - r < 0) { b.fx += -Cwall * (b.x - r) - B1 * b.vx; }

                b.vx += b.fx / m * dt;        b.vy += b.fy / m * dt;
                b.x += b.vx * dt;             b.y += b.vy * dt;
            }
        }
    }

    // 

    var rScale13 = r * scale * 1.3;         // ___  ___
    var rScaleShift = r * scale / 5;        // ___  ___
    function draw() {
        context.clearRect(0, 0, w * scale, h * scale);      //  
        for (var i = 0; i < balls.length; i++){
            var xS = balls[i].x * scale;           var yS = balls[i].y * scale;
            //       
            var gradient = context.createRadialGradient(xS, yS, rScale13, xS - rScaleShift, yS + rScaleShift, 0);
            gradient.addColorStop(0, "#0000bb");
            gradient.addColorStop(1, "#44ddff");
            context.fillStyle = gradient;

            context.beginPath();
            context.arc(xS, yS, r * scale, 0, 2 * Math.PI, false);
            context.closePath();
            context.fill();
        }
    }

    //  
    for (var i = 0; i < 20; i++)            //  20 ,    
        addNewBall(Math.random() * (w - 2 * r) + r, Math.random() * (h - 2 * r) + r);
    setInterval(control, 1000 / fps);
}